//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame   = PERIOD_CURRENT;
extern int                HmaLength   = 14;
extern ENUM_APPLIED_PRICE Price       =  0;
extern double             Power       =  2;
extern int                linesWidth  =  5;
extern bool               Interpolate = true;
extern bool               MultiColor  = true;

//
//
//
//
//

double hull[];
double hullDa[];
double hullDb[];
double slope[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   int type = DRAW_NONE; if (MultiColor) type = DRAW_LINE;
   IndicatorBuffers(4);
      SetIndexBuffer(0,hull);
      SetIndexStyle(0,EMPTY,EMPTY,linesWidth);
      SetIndexBuffer(1,hullDa); SetIndexStyle(1,type);SetIndexStyle(1,EMPTY,EMPTY,linesWidth);
      SetIndexBuffer(2,hullDb); SetIndexStyle(2,type);SetIndexStyle(2,EMPTY,EMPTY,linesWidth);
      SetIndexBuffer(3,slope);

      //
      //
      //
      //
      //
         
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);

      //
      //
      //
      //
      //
   
   IndicatorShortName(timeFrameToString(TimeFrame)+" Hull moving average ("+HmaLength+")");
   return(0);
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { hull[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
      int HalfPeriod = MathFloor(HmaLength/2);
      int HullPeriod = MathFloor(MathSqrt(HmaLength));
         if (slope[limit]==-1) CleanPoint(limit,hullDa,hullDb);
      
      //
      //
      //
      //
      //
      
      for(int i=limit; i>=0; i--)
      {
         double price   = iMA(NULL,0,1,0,MODE_SMA,Price,i);
                hull[i] = iLwmp(2.0*iLwmp(price,HalfPeriod,Power,i,0)-iLwmp(price,HmaLength,Power,i,1),HullPeriod,Power,i,2);
                hullDa[i] = EMPTY_VALUE;
                hullDb[i] = EMPTY_VALUE;
                slope[i]  = slope[i+1];
                  if (hull[i]>hull[i+1]) slope[i]=  1;
                  if (hull[i]<hull[i+1]) slope[i]= -1;
                  if (slope[i] == -1) PlotPoint(i,hullDa,hullDb,hull);
      }            
      return(0);
   }
   
   //
   //
   //
   //
   //
   

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (slope[limit]==-1) CleanPoint(limit,hullDa,hullDb);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         slope[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HmaLength,Price,Power,3,y);
         hull[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HmaLength,Price,Power,0,y);
         hullDa[i] = EMPTY_VALUE;
         hullDb[i] = EMPTY_VALUE;
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int j = 1; j < n; j++)
               hull[i+j] = hull[i] + (hull[i+n]-hull[i])*j/n;
   }
   for(i=limit; i>=0; i--) if (slope[i] == -1) PlotPoint(i,hullDa,hullDb,hull);
   return(0);         
}

  
//------------------------------------------------------------------
//                                                                 
//------------------------------------------------------------------
//
//
//
//
//

double workLwmp[][3];
double iLwmp(double price, double period, double power, int r, int instanceNo=0)
{
   if (ArrayRange(workLwmp,0)!= Bars) ArrayResize(workLwmp,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workLwmp[r][instanceNo] = price;
      double sumw = MathPow(period,power);
      double sum  = sumw*price;
      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = MathPow(period-k,power);
                sumw  += weight;
                sum   += weight*workLwmp[r-k][instanceNo];  
      }             
   return(sum/sumw);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}